const consts  = require('./const')
const version = require('./../package.json').version

exports.logo = () => {
  console.log(consts.CLI_BG_GREEN, consts.CLI_FG_BLACK, '    _  _   _   ___    _     '+consts.CLI_RESET)
  console.log(consts.CLI_BG_GREEN, consts.CLI_FG_BLACK, ' _ | | \\ \\/ / |   \\  | |    '+consts.CLI_RESET)
  console.log(consts.CLI_BG_GREEN, consts.CLI_FG_BLACK, '| || |  >  <  | |) | | |__  '+consts.CLI_RESET)
  console.log(consts.CLI_BG_GREEN, consts.CLI_FG_BLACK, ' \\__/  /_/\\_\\ |___/  |____| '+consts.CLI_RESET)
  console.log(consts.CLI_BG_GREEN, consts.CLI_FG_BLACK, '                            '+consts.CLI_RESET)
  console.log(consts.CLI_RESET);
}

exports.welcome = () => {
  exports.logo()
  console.log(consts.CLI_BLINK + 'Thanks for using JXDL, regards johobalboa')
  console.log(consts.CLI_RESET)
}

exports.version = () => {
  console.log('jxdl@'+version, 'copyright by Mortal Soft')
}

exports.help = () => {
  console.log(blue('Usage:'), 'jxdl', green('<url>'), yellow('[options]'))
  console.log()

  console.log(green('url'),'   Joox URL')
  console.log()

  console.log(blue('Options:'))
  console.log('  ' + yellow('-v') + ', ' + yellow('--version')+ '   Show version number')
  console.log('  ' + yellow('-h') + ', ' + yellow('--help')+ '      Show this help')
  console.log('  ' + yellow('-q') + ', ' + yellow('--quality')+ '   Song quality, one of the following')
  console.log('                  128     128 kbps (DEFAULT)')
  console.log('                  192     192 kbps')
  console.log('                  320     320 kbps')
  console.log('                  m4a     m4a kbps')
  console.log('  ' + yellow('-d') + ', ' + yellow('--dir')+ '       Download location directory     [path]')
  console.log('                  __dirname is DEFAULT')
  console.log('  ' + yellow('-f') + ', ' + yellow('--folder')+ '    Folder name                   [string]')
  console.log('                  Based on the list name is DEFAULT')
  console.log('  ' + yellow('-s') + ', ' + yellow('--skip')+ '      How many skip song in list    [number]')
  console.log()

  console.log(blue('Examples:'))
  console.log('   jxdl', green('http://www.joox.com/id/en/ranking'), yellow('-s 40 -q 320'))
  console.log()
  exports.version()
}

exports.missing = () => {
  console.log()
  console.log(red('Missing required argument: url'))
  console.log() 
}

exports.error = (s) => {
  console.log(red(s))
}

exports.infoList = (info, options) => {
  console.log(blue('Name            : ' + info.name))
  console.log(blue('Total Song      : ' + info.songTotal))
  console.log(blue('Quality         : ' + (options.q || options.quality || fixQuality(consts.QUALITY_128) )))
  console.log(blue('Directory       : ' + (options.d || options.dir || process.cwd())))
}

exports.infoSong = (filename) => {
  console.log()
  console.log(blue('Download Song => ' + filename))
}

const fixQuality = (quality) => {
  return (quality == 'm4a') ? quality + ' format' : quality.replace('q','')
}

const blue = (s) => {
  return consts.CLI_FG_BLUE+s+consts.CLI_RESET
}

const green = (s) => {
  return consts.CLI_FG_GREEN+s+consts.CLI_RESET
}

const yellow = (s) => {
  return consts.CLI_FG_YELLOW+s+consts.CLI_RESET
}

const red = (s) => {
  return consts.CLI_FG_RED+s+consts.CLI_RESET
}